// BkDoc.h : interface of the CBkDoc class
//________________________________________
class CBkDoc : public CDocument
{
protected: // create from serialization only
	CBkDoc();
	DECLARE_DYNCREATE(CBkDoc)

// Attributes
public:
	class CBkApp *m_pApp;
	//Noms fichiers_________________________
	CString 
		m_sNomFicTxt,
		m_sNomFic;
	//Paramtres de la fentre______________
	float
		m_fXmi,m_fYmi,m_fXma,m_fYma,
		m_fFactx,m_fFacty,
		m_fEchx,m_fEchy,
		m_fXori,m_fYori;
	//Textes________________________________
	//float
		//m_fHautTexte,
		//m_fCoefTexte;
	//Port srie
	short	m_radioPortSerie,m_radioCom;
	//Acquisition___________________________
	short
		m_iNbMax,
		m_iNb;
	float (*m_fT)[6];
	//Informations trac____________________
 	CStringArray m_sTab;
 	float
 		m_fXinfo,m_fYinfo;
 	BOOL 
 		m_OKinfo,
		m_OKPara;
	//Acquisition___________________________
 	short
 		m_iVoie,
 		m_radioVoieAcq,			//0:Voie 1, 1:Voie2, 2:Voie 1 & 2, 3:MATH sur TDS210
		m_iTypeAcq,
 		m_iTypeGr;					//Voir Bkdoc.cpp
 	float
 		//m_fXincr,						//Priode d'chantillonnage oscillo
 		//m_fPtOff,						//Dcalage en temps
 		
 		m_fAmplitude[2],		//Paramtres oscillo pour Michel
 		m_fCrms[2],
 		m_fMean[2],
 		m_fFrequence[2];
	//Rgressions___________________________
	BOOL
		m_OKReg;					//Bote de dialogue non modale
	class CRegres* m_pReg;
	//Zoom__________________________________
	float
		m_fZoomXmi,m_fZoomXma,m_fZoomYmi,m_fZoomYma;	//Paramtres zoom
	BOOL 
		m_OKZoom;
	CRectTracker m_tracker;
	//Extracton code________________________
	BOOL m_OKExCo;
	//Code barres___________________________
	CString m_sCode;
	//Rotation code barres__________________
	short m_iRot;
	//Couleurs______________________________
	unsigned long m_lCb[8],m_lCf[8];
	//Epaisseur trait simple et espace simple
	float 
		m_fCoef,
		m_fEpaisT[8],m_fEpaisE[8];
	//Image_________________________________
	short m_iL,m_iH,m_iNbB;
	typedef struct
	{
		unsigned char *ibuff;						// Image buffer address 
		unsigned stx,sty,endx,endy;			// Image area to be processed (pixel coords) 
		unsigned buffwidth;							// Image buffer width in bytes 
		RGBQUAD far *palette;						// Address of palette associated with the image 
		int colors;											// Palette colors 
		int imgtype;										// Image type: bit 0 = 1 if image is grayscale 
		BITMAPINFOHEADER far *bmh;			// BITMAPINFOHEADER header and DIB address 
		HBITMAP hBitmap;								// Device-independent bitmap handle 
	}
	imgdes;
	imgdes *image;		

	//Fichier bk.$$$________________________
	CFile m_Fic;
	int m_iNbCar;
	BOOL m_OKOuvert;
											

// Operations
public:
	void ColonnesTableau(short NoGr, short *ColT,short *ColU);
	void Zoom(float xmi,float ymi,float xma,float yma);
	void InitZoom(void);
	CString Renvoie_buffer(void);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBkDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
