// ConRs1Dlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "ConRs1Dlg.h"
#include "BkDoc.h"
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CConRs1Dlg dialog
CConRs1Dlg::CConRs1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConRs1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConRs1Dlg)
	m_sTexte1 = _T("");
	m_sTexte2 = _T("");
	//}}AFX_DATA_INIT
	Create(IDD_CONNEXION1,pParent);
}
void CConRs1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConRs1Dlg)
	DDX_Text(pDX, IDC_EDIT1, m_sTexte1);
	DDX_Text(pDX, IDC_STATIC2, m_sTexte2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CConRs1Dlg, CDialog)
	//{{AFX_MSG_MAP(CConRs1Dlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CConRs1Dlg message handlers
BOOL CConRs1Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	setlocale(LC_TIME,"French");
	m_pApp=(CBkApp*)AfxGetApp();
	//Pointeur sur le document en SDI
	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	}
	else
		m_pDoc=NULL;
	m_sTexte2="";
	m_sTexte1="";
	return TRUE;
}
//________________________________________
HANDLE CConRs1Dlg::Connexion(int radioCom) 
{
	DCB dcb;
	BOOL ok;

	m_radioCom=radioCom;
	switch (m_radioCom)
	{
		case 0://COM1
			m_hCom=CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
		case 1://COM2
			m_hCom=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
	}
	if (m_hCom==INVALID_HANDLE_VALUE)
	{
		m_sTexte2.Format("Erreur de connexion au port COM%d !",m_radioCom+1);
		UpdateData(FALSE);	
	}
	else
	{
		GetCommState(m_hCom,&dcb);
		//Paramtres du port srie
		//9600,7,'N',1
		dcb.BaudRate=CBR_9600;		//9600 bauds
		dcb.ByteSize=8;						//8 bits
		dcb.StopBits=ONESTOPBIT;	//ONESTOPBIT;//1 bit stop
		dcb.fParity=1;						//Enable parity checking
		dcb.Parity=0;							//0:no, 1:odd, 2:even, 3:mark, 4:space
		//Dans StdAfx.h:
		//#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers
		SetCommState(m_hCom,&dcb);
		COMMTIMEOUTS ctmo;
		ok=GetCommTimeouts(m_hCom,&ctmo);
		if (ok)
		{
			ctmo.ReadIntervalTimeout=MAXDWORD;
			ctmo.ReadTotalTimeoutMultiplier=0;
			ctmo.ReadTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutMultiplier=0;
			SetCommTimeouts(m_hCom,&ctmo);
		}
		m_t1=CTime::GetCurrentTime();   
		m_OKBusy=FALSE;SetTimer(99,1,NULL);
	}
	m_pDoc->m_OKOuvert=FALSE;
	//m_iNbC=0;
	return m_hCom;
}
//________________________________________
void CConRs1Dlg::Fermer(void)
{
	KillTimer(99);
	CloseHandle(m_hCom);
	//Si le fichier bk.$$$ est ouvert
	if (m_pDoc->m_OKOuvert)
	{ 
		m_pDoc->m_Fic.Close();
		m_pDoc->m_OKOuvert=FALSE;
	}
	CDialog::OnCancel();
}
//________________________________________
BOOL CConRs1Dlg::ReadCom(void)
{
	//Les caractres retourns sont crits dans le fichier bk.$$$ et dans la ligne m_sLigne
	BOOL ok,ok1=FALSE;
	DWORD q;
	unsigned char c[1];
	float r;
	int i;
	CFileException p_Error;
	CString s,s1;

	do
	{
		ok=ReadFile(m_hCom,c,1,&q,NULL);
		if (ok && q!=0)
		{
			m_t3=CTime::GetCurrentTime();//Un caracttre a t reu  l'instant m_t3
			//__________________________________			
			if (m_pDoc->m_OKOuvert==FALSE)
			{
				//Le fichier bk.$$$ n'est pas ouvert, on l'ouvre...
				m_pDoc->m_OKOuvert=TRUE;
				m_OK=m_pDoc->m_Fic.Open("bk.$$$",CFile::modeWrite|CFile::modeCreate,&p_Error);
				m_pDoc->m_iNbCar=0;	//Nb. de caractres dans le fichier bk.$$$
			}
			//On crit le caractre dans le fichier bk.$$$ et dans la chane m_sLigne (dernire ligne reue)
			if (m_pDoc->m_OKOuvert==TRUE && m_OK==TRUE)
			{
				s.Format("%c",c[0]);
				//Fichier bk.$$$
				m_pDoc->m_Fic.Write(&(c[0]),1);
				m_pDoc->m_iNbCar++;
			}
			/*
			//__________________________________			
			if (c[0]!='\n' && c[0]!='\r')
			{
				m_sTexte1=m_sTexte1+c[0];
			}
			else
			{
				//Fin de ligne rencontre
				m_sTexte1=m_sTexte1+"  "; 
			}
			*/
			if (m_sTexte1.GetLength()>172)	m_sTexte1="... "+m_sTexte1.Right(172);
			//On affiche non pas le caractre mais son code ASCII en dcimal
			/*
			if (c[0]>=20 && c[0]<=122)
			{
			}
			else
			*/
			{
				s.Format("%02X ",c[0]);
			}
			m_sTexte1=m_sTexte1+s;
			ok1=TRUE;
		}			
	}
	while (ok && q);
	return ok1;
}
//________________________________________
BOOL CConRs1Dlg::WriteCom(CString s)
{
	DWORD i;
	BOOL ok;
	if (m_hCom!=INVALID_HANDLE_VALUE)
	{
		ok=WriteFile(m_hCom,s,s.GetLength(),&i,NULL);
	}
	else
		ok=FALSE;
	return ok;
}
//________________________________________
void CConRs1Dlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	//Rception sur port srie
	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		/*ok=*/ReadCom();
		m_t2=CTime::GetCurrentTime();
		CTimeSpan t=m_t2-m_t1,t1;
		s=t.Format("%H:%M:%S");
		m_sTexte2.Format("Connect  COM%d:9600,8,'N',1 depuis %s\nLe fichier tampon contient %d caractre(s).",m_radioCom+1,s,m_pDoc->m_iNbCar);

		//Des caractres non traits sont dans le buffer
		t1=m_t2-m_t3;
		if (t1.GetTotalSeconds()>1 && m_pDoc->m_OKOuvert)
		{
			//Si a fait plus de 1 s qu'on n'a rien reu
			//Si le fichier bk.$$$ est ouvert
			m_pDoc->m_Fic.Close();
			m_pDoc->m_OKOuvert=FALSE;
		}
		UpdateData(FALSE);
		m_OKBusy=FALSE;
	}
	CDialog::OnTimer(nIDEvent);
}
