// EuroDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "EuroDlg.h"
#include "BkDoc.h"
#include "Eurosmart.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CEuroDlg dialog
CEuroDlg::CEuroDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEuroDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEuroDlg)
	m_s = _T("");
	m_radioType = -1;
	//}}AFX_DATA_INIT
}
void CEuroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEuroDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDACQ_PAS, m_btnAcqPas);
	DDX_Control(pDX, IDACQ, m_btnAcq);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Radio(pDX, IDC_RADIO1, m_radioType);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CEuroDlg, CDialog)
	//{{AFX_MSG_MAP(CEuroDlg)
	ON_BN_CLICKED(IDACQ, OnAcq)
	ON_BN_CLICKED(IDACQ_PAS, OnPas)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CEuroDlg message handlers
BOOL CEuroDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_pDoc=m_pApp->GetDocument();
	m_pEuro=new CEurosmart();
	m_s="?";
	UpdateData(FALSE);

	m_iNb=-1;

	//Mise : 0 0 0 0 0 0 0 1
	m_pEuro->outputio(1);
	m_radioType=0;m_iTempo=10;

	m_s="En mode Debug, une tempo de 2s est gnre aprs chaque front.";
	UpdateData(FALSE);
	return TRUE;
}
//_________________________________________________
void CEuroDlg::OnOK() 
{
	//CDialog::OnOK();
}
//_________________________________________________
void CEuroDlg::OnCancel() 
{
	//Mise : 0 0 0 0 0 0 0 1
	m_pEuro->outputio(1);
	delete m_pEuro;
	CDialog::OnCancel();
}
//_________________________________________________
void CEuroDlg::OnAcq() 
{
	m_iNb1=0;
	m_btnCancel.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(FALSE);
	m_btnAcqPas.EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO1)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO2)->EnableWindow(FALSE);
	SetTimer(1,50,NULL);

/*
	for (k=1;k<=120;k++)
	{
		//Mise : 0 0 0 0 0 0 1 0
		m_pEuro->outputio(2);
		Sleep(1);
		//Mise : 0 0 0 0 0 0 0 0
		m_pEuro->outputio(0);
		Sleep(1);
		pf=m_pEuro->inputio();
		Sleep(1);

		//Mise : 0 0 0 0 0 0 1 0
		m_pEuro->outputio(2);
		Sleep(1);
		//Mise : 0 0 0 0 0 0 0 0
		m_pEuro->outputio(0);
		Sleep(1);
		pF=m_pEuro->inputio();
		Sleep(1);

		nb=pf+pF*256;
		if (nb>1200) 
		{
			nb=1200;
			m_s.Format("%d: Hex: ?",k);
		}
		else
		{
			m_s.Format("%d: Hex:%lX (%lu)",k,nb,nb);
		}
		for (i=0;i<nb/60;i++)
		{
			if (m_iNb1<m_pDoc->m_iNbMax)
			{
				m_pDoc->m_fT[m_iNb1][0]=m_iNb1;			
				if (k%2) 
					//k pair
					m_pDoc->m_fT[m_iNb1][1]=0;			
				else
					//k impair
					m_pDoc->m_fT[m_iNb1][1]=1;			
				m_iNb1++;
			}
		}
		UpdateData(FALSE);
	}
	//Mise : 0 0 0 0 0 0 0 1 -> Fin de lecture
	m_pEuro->outputio(1);
	m_pDoc->UpdateAllViews(NULL);
	*/
}
//_________________________________________________
void CEuroDlg::OnTimer(UINT nIDEvent) 
{
	unsigned long nb;
	short i;
	if (m_iNb==-1)
	{
		//On met le bit lecture  zro et on initialise le tableau m_fT
		PremiereFois();
	}
	else
	if (m_iNb==0)
	{
		//Sans intrt...
		m_ipf=LectOctet(m_iTempo);
	}
	else
	if (m_iNb==1)
	{
		//Sans intrt...
		m_ipf=LectOctet(m_iTempo);
	}
	else

	if (m_iNb==2)
	{
		//Sans intrt...
		m_ipF=LectOctet(m_iTempo);

		//Juste pour avoir un front au dbut
		for (i=0;i<2;i++)
		{
			if (m_iNb1<m_pDoc->m_iNbMax)
			{
				m_pDoc->m_fT[m_iNb1][0]=m_iNb1;			
				m_pDoc->m_fT[m_iNb1][1]=0;			
				m_iNb1++;
			}
		}

	}
	else
	if ((m_iNb%2))
	{
		m_ipf=LectOctet(m_iTempo);
		//m_s.Format("(%d) pf: %d (Hex: %X)\nPoids faible mmoris...",m_iNb,m_ipf,m_ipf);
	}
	else
	{
		m_ipF=LectOctet(m_iTempo);
		nb=m_ipf+m_ipF*256;
		if (m_OK)
		{
			m_s.Format("(%d)\nN:%lu (%X)\nBarre, criture mot N  16 bit...",m_iNb,m_ipF,m_ipf,nb,nb);
		}
		else
		{
			m_s.Format("(%d)\nN:%lu (%X)\nEspace, criture mot N  16 bit...",m_iNb,m_ipF,m_ipf,nb,nb);
		}
		/*
		if (nb>1200)
		{
			nb=1200;
		}
		*/
		for (i=0;i<nb/10;i++)
		{
			if (m_iNb1<m_pDoc->m_iNbMax)
			{
				m_pDoc->m_fT[m_iNb1][0]=m_iNb1;			
				if (m_OK) 
				{
					m_pDoc->m_fT[m_iNb1][1]=1.05;			
				}
				else
					m_pDoc->m_fT[m_iNb1][1]=0;			
				m_iNb1++;
			}
		}
		m_OK=!m_OK;
	}
	m_iNb++;
	if (m_iNb>120) 
	{
		KillTimer(1);
		m_btnAcqPas.EnableWindow(TRUE);
		m_btnAcq.EnableWindow(TRUE);
		m_btnCancel.EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO1)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO2)->EnableWindow(TRUE);
		//Mise : 0 0 0 0 0 0 0 1 -> Fin de lecture
		m_pEuro->outputio(1);
		m_pDoc->UpdateAllViews(NULL);
		m_iNb=-1;
	}
	UpdateData(FALSE);
	
	CDialog::OnTimer(nIDEvent);
}
//__________________________________________________
void CEuroDlg::OnPas() 
{
	unsigned long nb;
	short i;
	m_btnAcq.EnableWindow(FALSE);
	if (m_iNb==-1)
	{
		//On met le bit lecture  zro et on initialise le tableau m_fT
		PremiereFois();
	}
	else
	if (m_iNb==0)
	{
		m_ipf=LectOctet(m_iTempo);
		m_s.Format("(%d) pf: %d (%X)\nOctet non pris en compte...",m_iNb,m_ipf,m_ipf);
	}
	else
	if (m_iNb==1)
	{
		m_ipf=LectOctet(m_iTempo);
		m_s.Format("(%d) pf: %d (%X)\nOctet non pris en compte...",m_iNb,m_ipf,m_ipf);
	}
	else
	if (m_iNb==2)
	{
		m_ipF=LectOctet(m_iTempo);
		m_s.Format("(%d) pF: %d (%X)\nOctet non pris en compte...",m_iNb,m_ipF,m_ipF);
		//Juste pour avoir un front au dbut
		for (i=0;i<2;i++)
		{
			if (m_iNb1<m_pDoc->m_iNbMax)
			{
				m_pDoc->m_fT[m_iNb1][0]=m_iNb1;			
				m_pDoc->m_fT[m_iNb1][1]=0;			
				m_iNb1++;
			}
		}

	}
	else
	if ((m_iNb%2))
	{
		m_ipf=LectOctet(m_iTempo);
		m_s.Format("(%d) pf: %d (%X)\nPoids faible mmoris...",m_iNb,m_ipf,m_ipf);
	}
	else
	{
		m_ipF=LectOctet(m_iTempo);
		nb=m_ipf+m_ipF*256;
		if (m_OK)
		{
			m_s.Format("(%d) pF: %d (%X), pf: %d (%X)\nN:%lu (%X)\nBarre, criture mot N  16 bit...",m_iNb,m_ipF,m_ipf,m_ipF,m_ipf,nb,nb);
		}
		else
		{
			m_s.Format("(%d) pF: %d (%X), pf: %d (%X)\nN:%lu (%X)\nEspace, criture mot N  16 bit...",m_iNb,m_ipF,m_ipf,m_ipF,m_ipf,nb,nb);
		}
		/*
		if (nb>1200)
		{
			nb=1200;
		}
		*/
		for (i=0;i<nb/10;i++)
		{
			if (m_iNb1<m_pDoc->m_iNbMax)
			{
				m_pDoc->m_fT[m_iNb1][0]=m_iNb1;			
				if (m_OK) 
				{
					m_pDoc->m_fT[m_iNb1][1]=1.05;			
					m_pDoc->UpdateAllViews(NULL);
				}
				else
					m_pDoc->m_fT[m_iNb1][1]=0;			
				m_iNb1++;
			}
		}
		m_OK=!m_OK;
	}

	m_iNb++;
	if (m_iNb>120) 
	{
		m_btnAcqPas.EnableWindow(FALSE);
		//Mise : 0 0 0 0 0 0 0 1 -> Fin de lecture
		m_pEuro->outputio(1);
	}
	UpdateData(FALSE);
	
}
//_________________________________________________
void CEuroDlg::PremiereFois() 
{
	unsigned char pf,pF;
	//Mise : 0 0 0 0 0 0 0 0  -> Lecture: mise  zro du bit 0
	m_pEuro->outputio(0);
	Sleep(1);
	m_s="Mise  zro du bit 0.\nPassage en mode lecture...";
	UpdateData(FALSE);
	Sleep(200);

	//Initialisation tableau
	short i;
	for (i=0;i<m_pDoc->m_iNbMax;i++)
	{
		m_pDoc->m_fT[i][0]=i;
		m_pDoc->m_fT[i][1]=0;
	}
	m_pDoc->m_iNb=m_pDoc->m_iNbMax;
	m_pDoc->m_iTypeGr=128+1;
	m_iNb1=0;m_OK=TRUE;
}
//_________________________________________________
unsigned char CEuroDlg::LectOctet(short Tempo) 
{
	unsigned char c;
	//Mise : 0 0 0 0 0 0 1 0
	m_pEuro->outputio(2);
	Sleep(Tempo);
	c=m_pEuro->inputio();
	//Mise : 0 0 0 0 0 0 0 0
	m_pEuro->outputio(0);
	Sleep(Tempo);
	return c;
}
//_________________________________________________
void CEuroDlg::OnRadio1() 
{
	UpdateData(TRUE);	
	m_iTempo=10;
	m_s="Pas de temporisation entre les fronts.";
	m_btnAcq.EnableWindow(TRUE);
	UpdateData(FALSE);	
}
//_________________________________________________
void CEuroDlg::OnRadio2() 
{
	UpdateData(TRUE);	
	m_iTempo=2000;	
	m_s="Temporisation de 2s entre les fronts.";
	m_btnAcq.EnableWindow(FALSE);
	UpdateData(FALSE);	
}
