// EuroDlg.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CEuroDlg dialog
class CEuroDlg : public CDialog
{
// Construction
public:
	CEuroDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CEuroDlg)
	enum { IDD = IDD_EUROSMART };
	CButton	m_btnCancel;
	CButton	m_btnAcqPas;
	CButton	m_btnAcq;
	CString	m_s;
	int		m_radioType;
	//}}AFX_DATA
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEuroDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkDoc* m_pDoc;
	class CBkApp* m_pApp;
	class CEurosmart* m_pEuro;
	short m_iNb,m_iNb1,m_iTempo;
	unsigned char m_ipf,m_ipF;
	BOOL m_OK;

	void PremiereFois();
	unsigned char LectOctet(short Tempo);

	// Generated message map functions
	//{{AFX_MSG(CEuroDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnAcq();
	afx_msg void OnPas();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
