// GeCoDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "GeCoDlg.h"
#include "bkdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CGeCoDlg dialog
CGeCoDlg::CGeCoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGeCoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGeCoDlg)
	m_s1 = _T("");
	m_s2 = _T("");
	m_s3 = _T("");
	m_s4 = _T("");
	//}}AFX_DATA_INIT
}
void CGeCoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGeCoDlg)
	DDX_Text(pDX, IDC_EDIT1, m_s1);
	DDX_Text(pDX, IDC_EDIT2, m_s2);
	DDX_Text(pDX, IDC_EDIT3, m_s3);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s4);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CGeCoDlg, CDialog)
	//{{AFX_MSG_MAP(CGeCoDlg)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeEdit2)
	ON_EN_CHANGE(IDC_EDIT3, OnChangeEdit3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CGeCoDlg message handlers
BOOL CGeCoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_s1.Format("%c",m_pDoc->m_sCode[0]);
	m_s2.Format("%c%c%c%c%c%c",m_pDoc->m_sCode[1],m_pDoc->m_sCode[2],m_pDoc->m_sCode[3],m_pDoc->m_sCode[4],m_pDoc->m_sCode[5],m_pDoc->m_sCode[6]);
	m_s3.Format("%c%c%c%c%c",m_pDoc->m_sCode[7],m_pDoc->m_sCode[8],m_pDoc->m_sCode[9],m_pDoc->m_sCode[10],m_pDoc->m_sCode[11]);
	m_s4.Format("%c",m_pDoc->m_sCode[12]);
	UpdateData(FALSE);
	return TRUE;
}
//__________________________________________________
void CGeCoDlg::OnOK() 
{
	int i;
	CString s;
	UpdateData(TRUE);
	i=CodeControle();
	s.Format("%d",i);
	//Calcul du code de contrle
	m_pDoc->m_sCode.SetAt(12,s[0]);
	m_pDoc->m_sCode.SetAt(0,m_s1[0]);
	if (m_s2.GetLength()>=6)
	{
		for (i=0;i<6;i++)
		{
			m_pDoc->m_sCode.SetAt(i+1,m_s2[i]);
		}
	}
	if (m_s3.GetLength()>=5)
	{
		for (i=0;i<5;i++)
		{
			m_pDoc->m_sCode.SetAt(i+7,m_s3[i]);

		}
	}
	m_pDoc->UpdateAllViews(NULL);
	m_pDoc->m_iTypeGr=0;
	CDialog::OnOK();
}
//__________________________________________________
short CGeCoDlg::CodeControle() 
{
	int n,p,i,k;
	CString s;
	p=0;
	i=0;
	if (m_s1.GetLength()>=1)
	{
		s.Format("%c",m_s1[0]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (m_s2.GetLength()>=1)
	{
		s.Format("%c",m_s2[0]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (m_s2.GetLength()>=2)
	{
		s.Format("%c",m_s2[1]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (m_s2.GetLength()>=3)
	{
		s.Format("%c",m_s2[2]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (m_s2.GetLength()>=4)
	{
		s.Format("%c",m_s2[3]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (m_s2.GetLength()>=5)
	{
		s.Format("%c",m_s2[4]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (m_s2.GetLength()>=6)
	{
		s.Format("%c",m_s2[5]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (m_s3.GetLength()>=1)
	{
		s.Format("%c",m_s3[0]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (m_s3.GetLength()>=2)
	{
		s.Format("%c",m_s3[1]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (m_s3.GetLength()>=3)
	{
		s.Format("%c",m_s3[2]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (m_s3.GetLength()>=4)
	{
		s.Format("%c",m_s3[3]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (m_s3.GetLength()>=5)
	{
		s.Format("%c",m_s3[4]);sscanf(s,"%u",&n);
		p=p+n;
	}
	n=p*3+i;
	//Ramener n  la dizaine suprieure
	short diz;
	diz=n/10;
	if (diz*10==n)
	{
		k=0;
	}
	else
	{
		diz=10+diz*10;
		k=diz-n;
	}
	return k;
}
//__________________________________________________
void CGeCoDlg::OnChangeEdit1() 
{
	UpdateData(TRUE);
	//Calcul du code de contrle
	short i=CodeControle();
	m_s4.Format("%d",i);
	UpdateData(FALSE);
}

void CGeCoDlg::OnChangeEdit2() 
{
	UpdateData(TRUE);
	//Calcul du code de contrle
	short i=CodeControle();
	m_s4.Format("%d",i);
	UpdateData(FALSE);
}

void CGeCoDlg::OnChangeEdit3() 
{
	UpdateData(TRUE);
	//Calcul du code de contrle
	short i=CodeControle();
	m_s4.Format("%d",i);
	UpdateData(FALSE);
}
