// LasDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "LasDlg.h"
#include "BkDoc.h"
#include "leuze.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CLasDlg dialog
CLasDlg::CLasDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLasDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLasDlg)
	m_s5 = _T("");
	//}}AFX_DATA_INIT
}
void CLasDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLasDlg)
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Text(pDX, IDC_STATIC5, m_s5);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CLasDlg, CDialog)
	//{{AFX_MSG_MAP(CLasDlg)
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CLasDlg message handlers
BOOL CLasDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	m_pLeuze=new CLeuze(m_pDoc->m_radioCom);
	m_s5="Cliquer sur Dmarrer...";
	m_OK=FALSE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CLasDlg::OnDemarrer() 
{
	if (!m_OK)
	{
		//Mise en route
		m_btnDemarrer.SetWindowText("&Arrter");
		m_s5="Faisceau prsent...";
		//Activation autoConfig
		m_pLeuze->WriteCom("CA+");
		//Mettre en marche le laser
		m_pLeuze->WriteCom("DL+");
	}
	else
	{
		//Arrt
		m_btnDemarrer.SetWindowText("&Dmarrer");
		m_s5="Faisceau arrt !";
		m_pLeuze->WriteCom("H");
	}
	m_btnCancel.EnableWindow(m_OK);
	m_OK=!m_OK;
	UpdateData(FALSE);
}
//________________________________________
void CLasDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CLasDlg::OnCancel() 
{
	delete m_pLeuze;
	
	CDialog::OnCancel();
}
