// LeLeuDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "LeLeuDlg.h"
#include "BkDoc.h"
#include "Leuze.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CLeLeuDlg dialog
CLeLeuDlg::CLeLeuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLeLeuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLeLeuDlg)
	m_s = _T("");
	//}}AFX_DATA_INIT
}
void CLeLeuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLeLeuDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDLIRE, m_btnLire);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CLeLeuDlg, CDialog)
	//{{AFX_MSG_MAP(CLeLeuDlg)
	ON_BN_CLICKED(IDLIRE, OnLire)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CLeLeuDlg message handlers
void CLeLeuDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CLeLeuDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	m_pLeuze=new CLeuze(m_pDoc->m_radioCom);
	m_s="Cliquer sur Lire...";
	UpdateData(FALSE);
	m_OK=FALSE;
	m_sCode="";
	return TRUE;
}
//________________________________________
void CLeLeuDlg::OnCancel() 
{
	delete m_pLeuze;	
	CDialog::OnCancel();
}
//________________________________________
void CLeLeuDlg::OnLire() 
{
	if (!m_OK)
	{
		//Lecture
		m_btnLire.SetWindowText("&Arrter");
		m_btnCancel.EnableWindow(FALSE);

		//Activation autoConfig
		m_pLeuze->WriteCom("CA+");

		//Mettre en marche le laser
		m_pLeuze->WriteCom("DL+");

		m_pLeuze->VideBuffer();
		m_OKBusy=FALSE;m_iNb=0;SetTimer(1,10,NULL);
	}
	else
	{
		//Arrt lecture
		KillTimer(1);
		m_btnLire.SetWindowText("&Lire");
		m_btnCancel.EnableWindow(TRUE);
		//RAZ logiciel
		m_pLeuze->WriteCom("H");
		m_s="Laser coup...";
		UpdateData(FALSE);
		m_pDoc->m_sCode=m_sCode;
		//Trac du code
		m_pDoc->m_iTypeGr=0;
		m_pDoc->UpdateAllViews(NULL);
	}
	m_OK=!m_OK;	
}
//________________________________________
void CLeLeuDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		//Attente code...
		m_iNb++;
		s=m_pLeuze->ReadBuf();
		if (s.GetLength()<19)
		{
			//On attend que le code arrive...
			m_s.Format("Attente code (%d) ...",m_iNb);
		}
		else
		{
			m_pLeuze->VideBuffer();
			s=s.Right(s.GetLength()-6);
			m_sCode=s;
			m_s.Format("Code lu: %s",s);
			UpdateData(FALSE);
			//RAZ logiciel
			m_pLeuze->WriteCom("H");
			Sleep(300);
			//Activation autoConfig
			m_pLeuze->WriteCom("CA+");
			Sleep(300);
			//Mettre en marche le laser
			m_pLeuze->WriteCom("DL+");
			Sleep(300);
			m_iNb=0;
		}
		m_OKBusy=FALSE;
	}
	UpdateData(FALSE);		
	CDialog::OnTimer(nIDEvent);
}
