// ParaDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ParaDlg.h"
#include "bkdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CParaDlg dialog
CParaDlg::CParaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParaDlg)
	m_fEpaisT = 0.0f;
	m_fEpaisE = 0.0f;
	m_radioCode = -1;
	m_fCoef = 0.0f;
	m_iRE = 0;
	m_iRT = 0;
	m_iBE = 0;
	m_iBT = 0;
	m_iVE = 0;
	m_iVT = 0;
	//}}AFX_DATA_INIT
}
void CParaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParaDlg)
	DDX_Text(pDX, IDC_EPAIS, m_fEpaisT);
	DDX_Text(pDX, IDC_EPAIS2, m_fEpaisE);
	DDX_Radio(pDX, IDC_RADIO_CODE0, m_radioCode);
	DDX_Text(pDX, IDC_COEF, m_fCoef);
	DDX_Text(pDX, IDC_RE, m_iRE);
	DDX_Text(pDX, IDC_RT, m_iRT);
	DDX_Text(pDX, IDC_BE, m_iBE);
	DDX_Text(pDX, IDC_VB, m_iBT);
	DDX_Text(pDX, IDC_VE, m_iVE);
	DDX_Text(pDX, IDC_VT, m_iVT);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CParaDlg, CDialog)
	//{{AFX_MSG_MAP(CParaDlg)
	ON_BN_CLICKED(IDC_RADIO_CODE0, OnRadioCode0)
	ON_BN_CLICKED(IDC_RADIO_CODE1, OnRadioCode1)
	ON_BN_CLICKED(IDC_RADIO_CODE2, OnRadioCode2)
	ON_BN_CLICKED(IDC_RADIO_CODE3, OnRadioCode3)
	ON_BN_CLICKED(IDC_RADIO_CODE4, OnRadioCode4)
	ON_BN_CLICKED(IDC_RADIO_CODE5, OnRadioCode5)
	ON_BN_CLICKED(IDC_RADIO_CODE6, OnRadioCode6)
	ON_BN_CLICKED(IDC_RADIO_CODE7, OnRadioCode7)
	ON_BN_CLICKED(IDCB, OnCb)
	ON_BN_CLICKED(IDCE, OnCe)
	ON_BN_CLICKED(IDIDEM, OnIdem)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CParaDlg message handlers
BOOL CParaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_fEpaisT=m_pDoc->m_fEpaisT[0];	
	m_fEpaisE=m_pDoc->m_fEpaisE[0];	
	m_iRT=m_pDoc->m_lCb[0]&255;
	m_iVT=(m_pDoc->m_lCb[0]>>8)&255;
	m_iBT=(m_pDoc->m_lCb[0]>>16)&255;
	m_iRE=m_pDoc->m_lCf[0]&255;
	m_iVE=(m_pDoc->m_lCf[0]>>8)&255;
	m_iBE=(m_pDoc->m_lCf[0]>>16)&255;

	m_fCoef=m_pDoc->m_fCoef;
	m_radioCodeDer=0;
	m_radioCode=0;
	UpdateData(FALSE);
	return TRUE;
}
//__________________________________________________
void CParaDlg::OnOK() 
{
	//CDialog::OnOK();
}
//__________________________________________________
void CParaDlg::OnRadioCode0() 
{
	GetDlgItem(IDC_EPAIS)->EnableWindow(TRUE);	
	GetDlgItem(IDC_EPAIS2)->EnableWindow(TRUE);
	Affecte();	
}
//__________________________________________________
void CParaDlg::OnRadioCode1() 
{
	GetDlgItem(IDC_EPAIS)->EnableWindow(FALSE);	
	GetDlgItem(IDC_EPAIS2)->EnableWindow(FALSE);	
	Affecte();	
}
//__________________________________________________
void CParaDlg::OnRadioCode2() 
{
	GetDlgItem(IDC_EPAIS)->EnableWindow(FALSE);	
	GetDlgItem(IDC_EPAIS2)->EnableWindow(FALSE);	
	Affecte();	
}
//__________________________________________________
void CParaDlg::OnRadioCode3() 
{
	GetDlgItem(IDC_EPAIS)->EnableWindow(FALSE);	
	GetDlgItem(IDC_EPAIS2)->EnableWindow(FALSE);	
	Affecte();	
}
//__________________________________________________
void CParaDlg::OnRadioCode4() 
{
	GetDlgItem(IDC_EPAIS)->EnableWindow(FALSE);	
	GetDlgItem(IDC_EPAIS2)->EnableWindow(FALSE);	
	Affecte();	
}
//__________________________________________________
void CParaDlg::OnRadioCode5() 
{
	GetDlgItem(IDC_EPAIS)->EnableWindow(FALSE);	
	GetDlgItem(IDC_EPAIS2)->EnableWindow(FALSE);	
	Affecte();	
}
//__________________________________________________
void CParaDlg::OnRadioCode6() 
{
	GetDlgItem(IDC_EPAIS)->EnableWindow(FALSE);	
	GetDlgItem(IDC_EPAIS2)->EnableWindow(FALSE);	
	Affecte();	
}
//__________________________________________________
void CParaDlg::OnRadioCode7() 
{
	GetDlgItem(IDC_EPAIS)->EnableWindow(FALSE);	
	GetDlgItem(IDC_EPAIS2)->EnableWindow(FALSE);
	Affecte();	
}
//__________________________________________________
void CParaDlg::Affecte() 
{
	short i;
	UpdateData(TRUE);
	if (m_fCoef<1) m_fCoef=1;
	if (m_fCoef>1.2) m_fCoef=1.2;
	if (m_fEpaisT<0.2) m_fEpaisT=0.2;
	if (m_fEpaisE<0.2) m_fEpaisE=0.2;
	m_pDoc->m_fCoef=m_fCoef;
	m_pDoc->m_fEpaisT[0]=m_fEpaisT;				//Epaisseur trait
	m_pDoc->m_fEpaisE[0]=m_fEpaisE;				//Epaisseur espace
	for (i=1;i<8;i++)
	{
		m_pDoc->m_fEpaisT[i]=m_pDoc->m_fEpaisT[i-1]*m_fCoef;
		m_pDoc->m_fEpaisE[i]=m_pDoc->m_fEpaisE[i-1]*m_fCoef;
	}
	m_pDoc->m_lCb[m_radioCodeDer]=m_iRT+m_iVT*256+m_iBT*256*256;
	m_pDoc->m_lCf[m_radioCodeDer]=m_iRE+m_iVE*256+m_iBE*256*256;

	m_iRT=m_pDoc->m_lCb[m_radioCode]&255;
	m_iVT=(m_pDoc->m_lCb[m_radioCode]>>8)&255;
	m_iBT=(m_pDoc->m_lCb[m_radioCode]>>16)&255;
	m_iRE=m_pDoc->m_lCf[m_radioCode]&255;
	m_iVE=(m_pDoc->m_lCf[m_radioCode]>>8)&255;
	m_iBE=(m_pDoc->m_lCf[m_radioCode]>>16)&255;
	UpdateData(FALSE);
	m_radioCodeDer=m_radioCode;
	m_pDoc->UpdateAllViews(NULL);
}
//_________________________________________________
void CParaDlg::OnCb() 
{
	short i;
	unsigned long cb;
	long w;
	CColorDialog d;
	i=d.DoModal();
	if (i!=IDCANCEL)
	{
		w=d.GetColor();
		m_iRT=w&255;
		m_iVT=(w>>8)&255;
		m_iBT=(w>>16)&255;
		UpdateData(FALSE);
		m_pDoc->m_lCb[m_radioCode]=w;
		m_pDoc->UpdateAllViews(NULL);
	}	
}
//_________________________________________________
void CParaDlg::OnCe() 
{
	//Couleur espace
	short i;
	unsigned long cb;
	long w;
	CColorDialog d;
	i=d.DoModal();
	if (i!=IDCANCEL)
	{
		w=d.GetColor();
		m_iRE=w&255;
		m_iVE=(w>>8)&255;
		m_iBE=(w>>16)&255;
		UpdateData(FALSE);
		m_pDoc->m_lCf[m_radioCode]=w;
		m_pDoc->UpdateAllViews(NULL);
	}
}
//_________________________________________________
void CParaDlg::OnCancel() 
{
	Affecte();
	CDialog::OnCancel();
}
//_________________________________________________
void CParaDlg::OnIdem() 
{
	//Couleurs des codes idem au code n1
	short i;
	for (i=1;i<8;i++)
	{
		m_pDoc->m_lCf[i]=m_pDoc->m_lCf[0];
		m_pDoc->m_lCb[i]=m_pDoc->m_lCb[0];
	}
	m_pDoc->UpdateAllViews(NULL);
}
