// AnaDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "AnaDlg.h"
#include "BkDoc.h"
#include "Code.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CAnaDlg dialog
CAnaDlg::CAnaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAnaDlg)
	m_fB = 0.0f;
	m_radioVoie = -1;
	m_sTexte = _T("");
	m_fT = 0.0f;
	m_fURef = 0.0f;
	//}}AFX_DATA_INIT
}
void CAnaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnaDlg)
	DDX_Control(pDX, IDTRAIT, m_btnTrait);
	DDX_Control(pDX, IDCODE, m_btnCode);
	DDX_Control(pDX, IDFRONT, m_btnFront);
	DDX_Text(pDX, IDC_B, m_fB);
	DDX_Radio(pDX, IDC_CH1, m_radioVoie);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Text(pDX, IDC_T, m_fT);
	DDX_Text(pDX, IDC_UREF, m_fURef);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAnaDlg, CDialog)
	//{{AFX_MSG_MAP(CAnaDlg)
	ON_BN_CLICKED(IDFRONT, OnFront)
	ON_BN_CLICKED(IDCODE, OnCode)
	ON_BN_CLICKED(IDTRAIT, OnTrait)
	ON_BN_CLICKED(IDC_CH1, OnCh1)
	ON_BN_CLICKED(IDC_CH2, OnCh2)
	ON_BN_CLICKED(IDC_MATH, OnMath)
	ON_BN_CLICKED(IDC_REF1, OnRef1)
	ON_BN_CLICKED(IDC_REF2, OnRef2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CAnaDlg message handlers
short CAnaDlg::RechercheFronts(void)
{
	short i,n;
	float 
		delta_t,
		u,t;
	char type;
	type='M';
	n=0;
	for (i=0;i<m_pDoc->m_iNbMax;i++)
	{
		u=m_pDoc->m_fT[i][m_icU];
		t=m_pDoc->m_fT[i][m_icT];

		if (u!=1e10 && t!=1e10)
		{
			//Calcul de uRef d'aprs rgression
			if (type=='D')
			{
				//On cherche le front descendant
				if (u<m_fURef)
				{
					if (n<100)//Nb. maxi de fronts
					{
						if (n<2)
						{
							//On mmorise...
							//m_fF[n]=t;
							//On prend le point d'avant
							m_fF[n]=m_pDoc->m_fT[i-1][m_icT];
							n++;
							type='M';
						}
						else
						{
							//On regarde si l'intervalle en temps est significatif par rapport au front prcdent
							delta_t=t-m_fF[n-1];
							if (delta_t>(m_fF[n-1]-m_fF[n-2])/4)
							{
								//On mmorise...
								//m_fF[n]=t;
								//On prend le point d'avant
								m_fF[n]=m_pDoc->m_fT[i-1][m_icT];
								n++;
								type='M';
							}
						}
					}	
				}
			}
			else
			{
				//On cherche le front montant
				if (u>m_fURef)
				{
					if (n<100)
					{
						if (n<2)
						{
							//On mmorise...
							//m_fF[n]=t;
							//On prend le point d'aprs
							m_fF[n]=m_pDoc->m_fT[i+1][m_icT];
							n++;
							type='D';
						}
						else
						{
							//On regarde si l'intervalle en temps est significatif par rapport au front prcdent
							delta_t=t-m_fF[n-1];
							if (delta_t>(m_fF[n-1]-m_fF[n-2])/4)
							{
								//On mmorise...
								//m_fF[n]=t;
								//On prend le point d'aprs
								m_fF[n]=m_pDoc->m_fT[i+1][m_icT];
								//CString z;z.Format("M:%f",m_fF[n]);AfxMessageBox(z);
								n++;
								type='D';
							}
						}
					}	
				}
			}
		}
	}
	return n;
}
//________________________________________
void CAnaDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CAnaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	m_fURef=2.3;
	if(m_pDoc->m_iTypeGr & 1) m_radioVoie=0;
	else         
	if(m_pDoc->m_iTypeGr & 2) m_radioVoie=1;         
	else
	if(m_pDoc->m_iTypeGr & 4) m_radioVoie=2;
	else
	if(m_pDoc->m_iTypeGr & 8) m_radioVoie=3;         
	else
	if(m_pDoc->m_iTypeGr & 16) m_radioVoie=4;
	else
	{
		//Le graphe prcdent n'tait pas un graphe d'acq. mais de calcul...
		if(m_pDoc->m_iTypeAcq & 1) m_radioVoie=0;
		else         
		if(m_pDoc->m_iTypeAcq & 2) m_radioVoie=1;         
		else
		if(m_pDoc->m_iTypeAcq & 4) m_radioVoie=2;
		else
		if(m_pDoc->m_iTypeAcq & 8) m_radioVoie=3;         
		else
		if(m_pDoc->m_iTypeAcq & 16) m_radioVoie=4;
	}         
	GetDlgItem(IDC_T)->EnableWindow(FALSE);
	GetDlgItem(IDC_B)->EnableWindow(FALSE);
	m_btnCode.EnableWindow(FALSE);
	m_btnTrait.EnableWindow(FALSE);

	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("Dfinir une zone puis cliquez sur Gnrer fronts pour dcoder le graphe U=f(t)...\n[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
	if(!(m_pDoc->m_iTypeAcq & 1)) GetDlgItem(IDC_CH1)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 2)) GetDlgItem(IDC_CH2)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 4)) GetDlgItem(IDC_REF1)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 8)) GetDlgItem(IDC_REF2)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 16)) GetDlgItem(IDC_MATH)->EnableWindow(FALSE);         

	m_fF=new float[100];
	m_fTP=new double[m_pDoc->m_iNbMax][2];

	m_pCode=new CCode();

	GetDlgItem(IDC_T)->EnableWindow(FALSE);
	GetDlgItem(IDC_B)->EnableWindow(FALSE);
	m_btnTrait.EnableWindow(FALSE);
	m_btnCode.EnableWindow(FALSE);

	return TRUE;
}
//________________________________________
void CAnaDlg::OnFront() 
{
	//Recherche des fronts montants et descendants
	float 
		u,u1,t,
		uMaxi,uMini,uMoy;
	short i,k;

	GetDlgItem(IDC_UREF)->EnableWindow(FALSE);
	GetDlgItem(IDC_B)->EnableWindow(FALSE);
	GetDlgItem(IDC_CH1)->EnableWindow(FALSE);
	GetDlgItem(IDC_CH2)->EnableWindow(FALSE);
	GetDlgItem(IDC_REF1)->EnableWindow(FALSE);
	GetDlgItem(IDC_REF2)->EnableWindow(FALSE);
	GetDlgItem(IDC_MATH)->EnableWindow(FALSE);
	m_btnFront.EnableWindow(FALSE);

	UpdateData(TRUE);
	if (m_fURef<0.1) m_fURef=0.1;
	if (m_fURef>10) m_fURef=10;
	UpdateData(FALSE);

	//Recherche indices colonnes tableau
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	//Calcul Umoy
	uMaxi=-1e10;uMini=1e10;
	for (i=0;i<m_pDoc->m_iNbMax;i++)
	{
		t=m_pDoc->m_fT[i][m_icT];
		u=m_pDoc->m_fT[i][m_icU];
		if (u!=1e10 && t!=1e10)
		{	
			if (u<uMini) uMini=u;
			if (u>uMaxi) uMaxi=u;
		}
	}
	uMoy=(uMaxi+uMini)/2;
	//Recherche des fronts
	m_iNbFront=RechercheFronts();//On devrait en trouver 2*30
	if (m_iNbFront>10 && m_iNbFront<90)
	{
		//Affectation colonnes 5 et 6 du tableau
		u1=-uMaxi+uMoy;
		k=0;
		for (i=0;i<m_pDoc->m_iNbMax;i++)
		{
			t=m_pDoc->m_fT[i][m_icT];
			u=m_pDoc->m_fT[i][m_icU];
			if (u!=1e10 && t!=1e10)
			{	
				if (t<m_fF[k])
				{
					//On reste sur le mme niveau
					m_pDoc->m_fT[i][4]=t;
					m_pDoc->m_fT[i][5]=uMoy+u1;
				}
				else
				{	
					//On est pass par un front
					u1=-u1;
					m_pDoc->m_fT[i][4]=m_pDoc->m_fT[i-1][4];
					m_pDoc->m_fT[i][5]=uMoy+u1;
					k++;
				}
			}
			else
			{
				m_pDoc->m_fT[i][5]=1e10;
				m_pDoc->m_fT[i][4]=1e10;
			}
		}
	}
	if (m_iNbFront>=60)
	{
		m_sTexte.Format("Nb. de fronts: %d\nConfirmer la largeur du trait simple T et de l'espace simple E...",m_iNbFront);
	}
	else
	{
		m_sTexte.Format("Nb. de fronts: %d (Insuffisant)\nConfirmer la largeur du trait simple T et de l'espace simple E...",m_iNbFront);
	}

	if (m_radioVoie==0) m_pDoc->m_iTypeGr=1;
	if (m_radioVoie==1) m_pDoc->m_iTypeGr=2;
	if (m_radioVoie==2) m_pDoc->m_iTypeGr=4;
	if (m_radioVoie==3) m_pDoc->m_iTypeGr=8;
	//Fronts en plus
	m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+64;

	GetDlgItem(IDC_T)->EnableWindow(TRUE);
	GetDlgItem(IDC_B)->EnableWindow(TRUE);
	m_btnTrait.EnableWindow(TRUE);
	
	m_pCode->TB(m_fF,m_iNbFront,&u,&u1);
	m_fT=u*m_pDoc->m_fFactx;m_fB=u1*m_pDoc->m_fFactx;
	UpdateData(FALSE);
	m_pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CAnaDlg::OnTrait() 
{
	//Confirmation largeur des traits
	UpdateData(TRUE);
	m_btnCode.EnableWindow(TRUE);
	m_btnTrait.EnableWindow(FALSE);
	GetDlgItem(IDC_T)->EnableWindow(FALSE);
	GetDlgItem(IDC_B)->EnableWindow(FALSE);

	if (m_fT<0.0001) m_fT=0.00001;
	if (m_fB<0.0001) m_fB=0.00001;

	m_sTexte.Format("Largeurs T et E confirmes.\nCliquer sur Analyser code...");
	UpdateData(FALSE);
}
//________________________________________
void CAnaDlg::OnCode() 
{
	//Extraction code barres  partir du tableau des fronts
	m_btnCode.EnableWindow(FALSE);
	UpdateData(TRUE);
	short er;
	er=m_pCode->Extraction(m_fF,m_iNbFront,m_fT/m_pDoc->m_fFactx,m_fB/m_pDoc->m_fFactx);
	if (er==0)
	{
		m_sTexte.Format("Code barre extrait: %s",m_pDoc->m_sCode);
		m_pDoc->SetTitle(m_pDoc->m_sCode+".cod");
	}
	else
	{
		m_sTexte.Format("Erreur(s) d'extraction du code barre:");
		if (er&1) m_sTexte=m_sTexte+"\n- Nb. de fronts insuffisant";
		if (er&2) m_sTexte=m_sTexte+"\n- Erreur d'extraction d'un chiffre gauche";
		if (er&16) m_sTexte=m_sTexte+"\n- Erreur d'extraction d'un chiffre droit";
		if (er&4) m_sTexte=m_sTexte+"\n- Erreur d'extraction code pays";
		//if (er&8) m_sTexte=m_sTexte+"\n- Erreur de parit (chiffre corrig)";
		if (er&8) m_sTexte=m_sTexte+"\n- Erreur de parit";
	}
	m_sTexte=m_sTexte+"\nCliquer sur Fermer...";	
	UpdateData(FALSE);
	//m_pDoc->m_iTypeGr=0;
}
//________________________________________
void CAnaDlg::OnCh1() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//________________________________________
void CAnaDlg::OnCh2() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//________________________________________
void CAnaDlg::OnRef1() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//________________________________________
void CAnaDlg::OnRef2() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//________________________________________
void CAnaDlg::OnMath() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//________________________________________
void CAnaDlg::OnCancel() 
{
	class CBkApp* pApp=(CBkApp*)AfxGetApp();
 	//Pas de marque de pointage, pas de coordonnes relatives
	pApp->m_fDx=0;
	pApp->m_fDy=0;

	m_pDoc->UpdateAllViews(NULL);
	delete[] m_fF;
	delete[] m_fTP;
	delete m_pCode;
	CDialog::OnCancel();
}
