class CCode
{
	public:
		//Constructeur de base
		CCode(class CDC *pDC);
		//Constructeur surcharg
		CCode();
		~CCode();
  
  //Attributes     
  public:
		void Affectation(void);
		void TraceCode(float x,float y,CString Code);
		void CodeRef(char Pos,float x,float y);
		void CodeChiffre(short Chiffre,short No,char Digit,float x,float y);
		void Couleur(unsigned long CoulB,unsigned long CoulF);
		void Taille(float T,float B,float H);
		short Extraction(float *m_fF, short Nb,float T,float B);
		short ExtractionGauche(float *m_fF, short Nb,float T,float B);
		short ExtractionDroite(float *m_fF, short Nb,float T,float B);
		void TB(float *m_fF,short NbF,float *T, float *B);
		short ChiffreG(float *m_fF,short *No,char *Type,float B,float T);
		short ChiffreD(float *m_fF,short *No,float B,float T);
		BOOL ChiffreCode(short n,short *pChiffre, char *pType);
		short MultipleT(float *m_fF,short No,float Ref,float *Mult);
		short MultipleB(float *m_fF,short No,float Ref,float *Mult);
		short CodeControle(CString Code);


	protected:
		//Codes de 1  9 en fonction des digits (tableau 1 sujet)
		short C[10][3];
		//Types pour codes de 1  6
		CString m_sType[10];
		float 
			m_fTrait,	//Epaisseur en mm du trait simple
			m_fBlanc,	//Epaisseur en mm de l'espace simple
			m_fT,			//Epaisseur en s du trait simple
			m_fB,			//Epaisseur en s de l'espace simple

			m_fHaut,	//Hauteur du code barre en mm
			m_fLarg;	//Largeur d'un chiffre du code en mm
		unsigned long 
			m_lCb,
			m_lCf;
		short m_iNbF;//Nb. de fronts
		class CDessin *m_pDes;
		class CDC *m_pDC;
		class CBkDoc *m_pDoc;
		CString m_sBinaire[60];
		float m_fMult[60];

		//Variable rajoute le 10/02/04
		short m_iTypeConstructeur;
};
