// ExCoDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ExCoDlg.h"
#include "BkDoc.h"
#include "Regres.h"
#include "Code.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CExCoDlg dialog
CExCoDlg::CExCoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExCoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExCoDlg)
	m_radioVoie = -1;
	m_sTexte = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_EXT_COD,pParent);
}
void CExCoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExCoDlg)
	DDX_Radio(pDX, IDC_CH1, m_radioVoie);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CExCoDlg, CDialog)
	//{{AFX_MSG_MAP(CExCoDlg)
	ON_BN_CLICKED(IDC_REF1, OnRef1)
	ON_BN_CLICKED(IDC_REF2, OnRef2)
	ON_BN_CLICKED(IDC_MATH, OnMath)
	ON_BN_CLICKED(IDC_CH1, OnCh1)
	ON_BN_CLICKED(IDC_CH2, OnCh2)
	ON_BN_CLICKED(IDEXTRAIRE, OnExtraire)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
void CExCoDlg::PostNcDestroy()
{
	delete this;
}
//__________________________________________________
void CExCoDlg::AffecteRect(float xmi,float ymi,float xma,float yma)
{
	CString s;
	s.Format("Limites:\nxmi: %1.3f, ymi: %1.3f\r\nxma: %1.3f, yma: %1.3f\n[%d][%d]",xmi,ymi,xma,yma,m_icT,m_icU);
	GetDlgItem(IDC_STATIC_TEXTE)->SetWindowText(s);
	m_fxmi=xmi/m_pDoc->m_fFactx;
	m_fxma=xma/m_pDoc->m_fFactx;
	m_fymi=ymi/m_pDoc->m_fFacty;
	m_fyma=yma/m_pDoc->m_fFacty;
}
//__________________________________________________
void CExCoDlg::Affecte(CBkDoc *pDoc)
{
	m_pDoc=pDoc;
	if(m_pDoc->m_iTypeGr & 1) m_radioVoie=0;
	else         
	if(m_pDoc->m_iTypeGr & 2) m_radioVoie=1;         
	else
	if(m_pDoc->m_iTypeGr & 4) m_radioVoie=2;
	else
	if(m_pDoc->m_iTypeGr & 8) m_radioVoie=3;         
	else
	if(m_pDoc->m_iTypeGr & 16) m_radioVoie=4;
	else
	{
		//Le graphe prcdent n'tait pas un graphe d'acq. mais de calcul...
		if(m_pDoc->m_iTypeAcq & 1) m_radioVoie=0;
		else         
		if(m_pDoc->m_iTypeAcq & 2) m_radioVoie=1;         
		else
		if(m_pDoc->m_iTypeAcq & 4) m_radioVoie=2;
		else
		if(m_pDoc->m_iTypeAcq & 8) m_radioVoie=3;         
		else
		if(m_pDoc->m_iTypeAcq & 16) m_radioVoie=4;
	}         
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("Dfinir la zone du code puis cliquer sur Extraire...     [%d][%d]\nL'extraction par moiti est possible, en incluant les barres rfrences...",m_icT,m_icU);
	UpdateData(FALSE);
	if(!(m_pDoc->m_iTypeAcq & 1)) GetDlgItem(IDC_CH1)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 2)) GetDlgItem(IDC_CH2)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 4)) GetDlgItem(IDC_REF1)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 8)) GetDlgItem(IDC_REF2)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 16)) GetDlgItem(IDC_MATH)->EnableWindow(FALSE);         

	m_fxmi=-1e10;
	m_fymi=-1e10;
	m_fxma=1e10;
	m_fyma=1e10;
}
//__________________________________________________
BOOL CExCoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	return TRUE;
}
//__________________________________________________
void CExCoDlg::OnOK() 
{
	//CDialog::OnOK();
}
//__________________________________________________
void CExCoDlg::OnCancel() 
{
	class CWnd* pParent=GetParent();
	class CMenu* pMenu=pParent->GetMenu();
	class CBkApp* pApp=(CBkApp*)AfxGetApp();
	//On peut maintenant re-ouvrir une bote de dialogue
	m_pDoc->m_OKExCo=FALSE;                         
	//On dcoche la rubrique du menu
	pMenu->CheckMenuItem(ID_EXTRACTION,MF_UNCHECKED);
  UpdateData(TRUE);

	//Pas de marque de pointage, pas de coordonnes relatives
	pApp->m_fDx=0;
	pApp->m_fDy=0;

	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnCancel();
}
//__________________________________________________
void CExCoDlg::OnCh1() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//__________________________________________________
void CExCoDlg::OnCh2() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//__________________________________________________
void CExCoDlg::OnRef1() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//__________________________________________________
void CExCoDlg::OnRef2() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//__________________________________________________
void CExCoDlg::OnMath() 
{
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&m_icT,&m_icU);
	m_sTexte.Format("[%d][%d]",m_icT,m_icU);
	UpdateData(FALSE);
}
//__________________________________________________
void CExCoDlg::OnExtraire() 
{
	short i;
	float u,t;
	for (i=0;i<m_pDoc->m_iNbMax;i++)
	{
		u=m_pDoc->m_fT[i][m_icU];
		t=m_pDoc->m_fT[i][m_icT];
		if (u!=1e10 && t!=1e10 && u>m_fymi && u<m_fyma && t>m_fxmi && t<m_fxma)
		{
		}
		else
		{
			m_pDoc->m_fT[i][m_icU]=1e10;
			m_pDoc->m_fT[i][m_icT]=1e10;
		}
	}
	/*
	m_fxmi=-1e10;
	m_fymi=-1e10;
	m_fxma=1e10;
	m_fyma=1e10;
	*/
	m_pDoc->m_tracker.m_rect.left=0;m_pDoc->m_tracker.m_rect.top=0;
	m_pDoc->m_tracker.m_rect.right=0;m_pDoc->m_tracker.m_rect.bottom=0;
	m_pDoc->UpdateAllViews(NULL);
}
