// MainFrm.cpp : implementation of the CMainFrame class
#include "stdafx.h"
#include "Bk.h"
#include "Bkdoc.h"
#include "MainFrm.h"
#include "Vicdefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMainFrame
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_SOURIS,OnMajBarreEtat)
	ON_UPDATE_COMMAND_UI(ID_AFFICHE_CODE,OnAffichageCode)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,						//Status line indicator
	ID_AFFICHE_CODE,				//Rajout: affichage du code barre
	ID_SOURIS,							//Rajout: coordonnes de la souris
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	//ID_INDICATOR_SCRL,
};
//////////////////////////////////////////
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}
CMainFrame::~CMainFrame()
{
}
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	//A ajouter...
	ShowWindow(SW_SHOWMAXIMIZED);
	
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	//Ouveture fentre  une taille agrandie
	//cs.cx=1024-40;
	//cs.cy=768-40;
	//cs.x=20;
	//cs.y=0;

	return CFrameWnd::PreCreateWindow(cs);
}
//////////////////////////////////////////
// CMainFrame diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}
void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}
#endif //_DEBUG
//////////////////////////////////////////
// CMainFrame message handlers
//Affichage coordonnes souris dans barre d'tat

void CMainFrame::OnMajBarreEtat(CCmdUI *pCmdUI)
{
  CString str;
	long 
		w,wR,wV,wB,
		w1,wR1,wV1,wB1;
	class CBkApp* pApp;
	class CBkDoc* pDoc;
	
	pApp=((CBkApp*)AfxGetApp());
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	m_wndStatusBar.SetPaneInfo(2,ID_SOURIS,SBPS_NORMAL,250);
	if (pDoc!=NULL)
	{
		if (pDoc->m_iTypeGr==32)
		{
			//Image
			if (pApp->m_iX<pDoc->m_iL && pApp->m_iY<pDoc->m_iH )
			{
				if (pApp->m_iDx==0 && pApp->m_iDy==0)
				{
					//Absolu
					w=getpixelcolor(pDoc->image,pApp->m_iX,pApp->m_iY);
					if (pDoc->m_iNbB==24)
					{
						wR=w&255;
						wV=(w>>8)&255;
						wB=(w>>16)&255;
						str.Format("X:%d, Y:%d, R:%d, V:%d, B:%d",pApp->m_iX,pApp->m_iY,wR,wV,wB);
					}
					else
					{	
						str.Format("X:%d, Y:%d, W:%d",pApp->m_iX,pApp->m_iY,w);
					}
				}
				else
				{
					//Relatif
					w=getpixelcolor(pDoc->image,pApp->m_iX,pApp->m_iY);
					w1=getpixelcolor(pDoc->image,pApp->m_iDx,pApp->m_iDy);
					if (pDoc->m_iNbB==24)
					{
						//Couleur
						wR=w&255;
						wV=(w>>8)&255;
						wB=(w>>16)&255;
						wR1=w1&255;
						wV1=(w1>>8)&255;
						wB1=(w1>>16)&255;
						str.Format("dX:%d, dY:%d, dR:%d, dV:%d, dB:%d",pApp->m_iX-pApp->m_iDx,pApp->m_iY-pApp->m_iDy,wR-wR1,wV-wV1,wB-wB1);
					}
					else
					{
						//Nuances de gris
						str.Format("dX:%d, dY:%d, dW:%d",pApp->m_iX-pApp->m_iDx,pApp->m_iY-pApp->m_iDy,w-w1);
					}
				}
			}
			else
			{
				str="";
			}
			pCmdUI->SetText(str); 
		}
		else
		{	
			if (pApp->m_fDx==1e10 && pApp->m_fDy==1e10)
				str.Format("x:%8.3f, y:%8.3f",pApp->m_fX,pApp->m_fY);
			else
				str.Format("dx:%8.3f, dy:%8.3f",pApp->m_fX-pApp->m_fDx,pApp->m_fY-pApp->m_fDy);
			pCmdUI->SetText(str); 
		}
	}
}
//________________________________________
void CMainFrame::OnAffichageCode(CCmdUI *pCmdUI)
{
	class CBkApp* pApp;
	class CBkDoc* pDoc;
	
	pApp=((CBkApp*)AfxGetApp());
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	m_wndStatusBar.SetPaneInfo(1,ID_AFFICHE_CODE,SBPS_NORMAL,150);
	if (pDoc!=NULL) pCmdUI->SetText(pDoc->m_sCode); 
}
