// RotDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "RotDlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CRotDlg dialog
CRotDlg::CRotDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRotDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRotDlg)
	m_OKRotX = FALSE;
	m_OKRotY = FALSE;
	//}}AFX_DATA_INIT
}
void CRotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRotDlg)
	DDX_Check(pDX, IDC_ROTX, m_OKRotX);
	DDX_Check(pDX, IDC_ROTY, m_OKRotY);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CRotDlg, CDialog)
	//{{AFX_MSG_MAP(CRotDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CRotDlg message handlers
BOOL CRotDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	if (m_pDoc->m_iRot&1)	m_OKRotX=TRUE;	
	if (m_pDoc->m_iRot&2) m_OKRotY=TRUE;	
	UpdateData(FALSE);
	return TRUE;
}
//__________________________________________________
void CRotDlg::OnOK() 
{
	float x,y,xm,ym,xmi=1e10,xma=-1e10,ymi=1e10,yma=-1e10;
	short i,colT,colU;

	UpdateData(TRUE);
	if (m_pDoc->m_iNb>0 && (m_OKRotX || m_OKRotY))
	{
		//Slection des graphes  visualiser
		if(m_pDoc->m_iTypeGr&1)
		{
			//CH1
			m_pDoc->ColonnesTableau(1,&colT,&colU);			
		}
		if(m_pDoc->m_iTypeGr&2)
		{
			//CH2
			m_pDoc->ColonnesTableau(2,&colT,&colU);			
		}
		if(m_pDoc->m_iTypeGr&4)
		{
			//REF1
			m_pDoc->ColonnesTableau(4,&colT,&colU);			
		}
		if(m_pDoc->m_iTypeGr&8)
		{
			//REF2
			m_pDoc->ColonnesTableau(8,&colT,&colU);			
		}
		if(m_pDoc->m_iTypeGr&16)
		{
			//MATH
			m_pDoc->ColonnesTableau(16,&colT,&colU);			
		}
		//Recherche extrmums
		for (i=0;i<m_pDoc->m_iNb;i++)
		{
			if (m_pDoc->m_fT[i][colT]!=1e10 && m_pDoc->m_fT[i][colU]!=1e10)
			{
				if (m_pDoc->m_fT[i][colT]<xmi) xmi=m_pDoc->m_fT[i][colT];
				if (m_pDoc->m_fT[i][colT]>xma) xma=m_pDoc->m_fT[i][colT];
				if (m_pDoc->m_fT[i][colU]<ymi) ymi=m_pDoc->m_fT[i][colU];
				if (m_pDoc->m_fT[i][colU]>yma) yma=m_pDoc->m_fT[i][colU];
			}
		}
		xm=(xma+xmi)/2;ym=(yma+ymi)/2;
		m_pDoc->m_iRot=0;
		if (m_OKRotX) m_pDoc->m_iRot=m_pDoc->m_iRot+1;
		if (m_OKRotY)
		{
			/*
			for (i=0;i<m_pDoc->m_iNbMax;i++)
			{
				x=m_pDoc->m_fT[i][colT]-xm;
				m_pDoc->m_fT[i][colT]=xm-x;
			}
			*/
			//Nouveau mode de retournement le 03/02/04 : Valeurs en x croissantes...
			float *T;T=new float[m_pDoc->m_iNb];
			for (i=0;i<m_pDoc->m_iNb;i++)
			{
				T[m_pDoc->m_iNb-1-i]=m_pDoc->m_fT[i][colU];
			}
			for (i=0;i<m_pDoc->m_iNb;i++)
			{
				m_pDoc->m_fT[i][colU]=T[i];
			}
			delete T;
		}
		if (m_OKRotX)
		{
			for (i=0;i<m_pDoc->m_iNb;i++)
			{
				y=m_pDoc->m_fT[i][colU]-ym;
				m_pDoc->m_fT[i][colU]=ym-y;
			}
		}
		m_pDoc->m_iRot=0;
		if (m_OKRotX) m_pDoc->m_iRot=m_pDoc->m_iRot+1;
		if (m_OKRotY) m_pDoc->m_iRot=m_pDoc->m_iRot+2;
		//Initialisation coordonnes souris
		m_pApp->m_fDx=1e10;
		m_pApp->m_fDy=1e10;
		m_pApp->m_iDx=0;
		m_pApp->m_iDy=0;

		m_pDoc->UpdateAllViews(NULL);

	}
	CDialog::OnOK();
}
