// ZoomDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ZoomDlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CZoomDlg dialog
CZoomDlg::CZoomDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZoomDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZoomDlg)
	m_sTexte = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_ZOOM,pParent);
}
void CZoomDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZoomDlg)
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CZoomDlg, CDialog)
	//{{AFX_MSG_MAP(CZoomDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CZoomDlg message handlers
void CZoomDlg::PostNcDestroy()
{
	delete this;
}
//__________________________________________________
void CZoomDlg::AffecteRect(float xmi,float ymi,float xma,float yma)
{
	CString s;
	s.Format("xmi: %1.3f, ymi: %1.3f\r\nxma: %1.3f, yma: %1.3f",xmi,ymi,xma,yma);
	GetDlgItem(IDC_STATIC_TEXTE)->SetWindowText(s);
	m_fxmi=xmi;
	m_fxma=xma;
	m_fymi=ymi;
	m_fyma=yma;
}
//__________________________________________________
void CZoomDlg::Affecte(CBkDoc *pDoc)
{
	m_pDoc=pDoc;
	m_sTexte="Tracer ou modifier le rectangle avec la souris...";
  UpdateData(FALSE);
	//On annule le zoom existant
	m_pDoc->InitZoom();
	//Pas de marque de pointage, pas de coordonnes relatives
	CBkApp* pApp=(CBkApp*)AfxGetApp();
	pApp->m_fDx=1e10;
	pApp->m_fDy=1e10;
	m_pDoc->UpdateAllViews(NULL);
}
//__________________________________________________
void CZoomDlg::OnCancel() 
{
	CWnd* pParent=GetParent();
	CMenu* pMenu=pParent->GetMenu();
	//On peut maintenant re-ouvrir une bote de dialogue
	m_pDoc->m_OKZoom=FALSE;                         
	//On dcoche la rubrique du menu
	pMenu->CheckMenuItem(ID_ZOOM,MF_UNCHECKED);
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnCancel();
}
//__________________________________________________
void CZoomDlg::OnOK() 
{
	CWnd* pParent=GetParent();
	CMenu* pMenu=pParent->GetMenu();
	//On peut maintenant re-ouvrir une bote de dialogue
	m_pDoc->m_OKZoom=FALSE;                         
	//On dcoche la rubrique du menu
	pMenu->CheckMenuItem(ID_ZOOM,MF_UNCHECKED);
	//On mmorise les paramtres de la zone...
	m_pDoc->Zoom(m_fxmi/m_pDoc->m_fFactx,m_fymi/m_pDoc->m_fFacty,m_fxma/m_pDoc->m_fFactx,m_fyma/m_pDoc->m_fFacty);
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnOK();
}
